void SetCommandPointer();
void (*PuntatoreFunzione[255])();

void Com_StringLength();
void Com_TurnOnLed();
void Com_TurnOffLed();
void Com_LedBlink();
void Com_Loop();
void Com_Delay();
void Com_CheckInput1();
void Com_CheckInput0();
void Com_CheckPressureInput1();
void Com_CheckPressureInput0();
void Com_CheckInputRegister();
void Com_SetOutput();
void Com_SetOutputToValue();
void Com_ResetOutput();
void Com_SetOutputRegister();
void Com_ResetOutputRegister();
void Com_TurnOnGSM();
void Com_TurnOnUART1();
void Com_AutomaticCallReply();
void Com_TurnOffGSM();
void Com_SendSMS();
void Com_ReadSMS();
void Com_DeleteSMS();
void Com_SendCall();
void Com_WaitIncommingCall();
void Com_EnableGSMAutoCheck();
void Com_DisableGSMAutoCheck();
void Com_StringMerge();
void Com_IntToString();
void Com_StringToInt();
void Com_CopyString();
void Com_StringAddCharacter();
void Com_FindString();
void Com_CutString();
void Com_LenString();
void Com_LoadStringDirect();
void Com_LoadString();
void Com_StoreStringDirect();
void Com_StoreString();
void Com_StringMerge();
void Com_IntToString();
void Com_LoadRegister();
void Com_CopyRegisterToRegister();
void Com_StoreRegister();
void Com_LoadRegisterDirect();
void Com_StoreRegisterDirect();
void Com_ConstantToRegister();
void Com_Sum();
void Com_Subtraction();
void Com_Division();
void Com_Multiplication();
void Com_OR();
void Com_AND();
void Com_IfEqual();
void Com_IfGreater();
void Com_IfMinor();
void Com_IfEqualDirect();
void Com_IfGreaterDirect();
void Com_IfMinorDirect();
void Com_TurnOnRS232USB();
void Com_TurnOnUART2();
void Com_TurnOffRS232USB();
void Com_txRS232USB();
void Com_rxRS232USB();
void Com_txRS232USBIntegerString();
void Com_txRS232USBInteger();
void Com_rxRS232USBIntegerString();
void Com_rxRS232USBCharacters();
void Com_TurnOnRS232GSM();
void Com_TurnOffRS232GSM();
void Com_txRS232GSM();
void Com_rxRS232GSM();
void Com_PowerDown();
void Com_TimerON();
void Com_TimerOFF();
void Com_CheckCallState();
void Com_ReplyCall();
void Com_CloseCall();
void Com_CheckBattery();
void Com_BeepBuzzer();
void Com_AnalogInput();
void Com_LoadVectorRegister();
void Com_StoreVectorRegister();
void Com_LoadVectorString();
void Com_StoreVectorString();
void Com_InitI2CMaster();
void Com_InitI2CSlave();
void Com_WriteMasterI2C();
void Com_ReadMasterI2C();
void Com_ReadI2CRegister();
void Com_WriteI2CRegister();
void Com_StoreI2CToFlash();
void Com_ReadI2CFromFlash();
void Com_WiFiEnable();
void Com_WiFiDisable();
void Com_WiFiWebConnect();
void Com_WiFiConnectionStatus();
void Com_WiFiPrepareWriteGET();
void Com_WiFiPrepareWriteIntGET();
void Com_WiFiPrepareReadGET();
void Com_WiFiData();
void Com_WiFiReadVariable();
void Com_WiFiReadIntVariable();
void Com_WiFiReboot();
void Com_TurnOnMODBUS();
void Com_MODBUSSendCommand();
void Com_MODBUSSendCommandByte();
void Com_MODBUSSendCommandRegister();
void Com_tx485();
void Com_rx485();
void Com_tx485Integer();
void Com_rx485Integer();
void Com_tx485Byte();
void Com_rx485Byte();
void Com_DisplayON();
void Com_DisplayWrite();
void Com_DisplayWriteAddress();
void Com_DisplayClear();
void Com_DisplayCursorON();
void Com_DisplayCursorOFF();
void Com_DisplayBackLightON();
void Com_DisplayBackLightOFF();
void Com_DisplayLine1();
void Com_DisplayLine2();
void Com_DisplayNextionWrite();
void Com_Program();
void Com_ProductionTest();


//----------------------------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------- L E D   F U N C T I O N S --------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------

//************************************************************ Turn ON LED ***************************************************************************
#define LED_ON 0
#define COMMAND.LED.LED_ON "Turn LED ON"()-OUTPUT.LEDOn

//*********************************************************** Turn OFF LED ***************************************************************************
#define LED_OFF 1
#define COMMAND.LED.LED_OFF "Turn LED OFF"()-OUTPUT.LEDOff

//************************************************************ Blink LED *****************************************************************************
#define BLINK 2
#define COMMAND.LED.BLINK "Blink LED"()-OUTPUT.LEDBlink

//----------------------------------------------------------------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------- M I S C   F U N C T I O N S ------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------

//*************************************************************** Jump *******************************************************************************
//PARAMETER
//16 bit [M]: Jump destination address
#define GOTO 10
#define COMMAND.JUMP.GOTO "Jump to state"(J16_1"Target state"){Target state=J16_1}-JUMP.Goto

//************************************************************** SLEEP *******************************************************************************
//PARAMETER
//8 bit  [R]: Index of the register that contains the delay value (msec)
#define SLEEP_MS 20
#define COMMAND.DELAY.SLEEP_MS "Delay ms"(RIn_1"Delay value in ms"){Delay=RIn_1}-OUTPUT.Delay

//----------------------------------------------------------------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------- I N P U T / O U T P U T   F U N C T I O N S ----------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------

//*********************************************************** Check Input ****************************************************************************
//PARAMETER
//8 bit  [I]: Input selector.     1: Input1, 2: Input2, 3: Input3, 4: Input4, 5: Input5, 6:Switch1, 7:Switch2
//8 bit  [I]: Input control mode. 0: Check if the input value is '1' (without debounce),
//                                1: Check if the input value is '1' (with debounce),
//                                2: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds.
//                                3: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds with beep.
//16 bit [I]: Jump address if input is '1'.
//16 bit [I]: Jump address if input stays at '1' for more that 2 seconds.
#define CHECK_INPUT_1 30
#define COMMAND.IO.CHECK_INPUT_1 "Test if Input = '1'"(In8_1(1:Input1, 2:Input2, 3:Input3, 4:Input4, 5:Input5, 6:Switch1, 7:Switch2)"Input to be checked", In8_2(0:Check if input is '1', 1:Check if input is '1' with debounce, 2:Check if input is '1' and if it stays '1' for more than 2 seconds, 3:Check if input is '1' and if it stays '1' for more than 2 seconds with beep)"Input control mode. 0: Return the input value, 1: Check if the input value is '1' (with debounce), 2: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds, 3: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds with beep.", J16_1"Jump target state if input is 1",J16_2"Jump target state if input stays at 1 for more that 2 seconds"){Check input In8_1<br>Type of control=In8_2<br>if IN In8_1=1<br>Jump to J16_1<br>if IN In8_1=1 for more 2 seconds<br>Jump to J16_2}-JUMP.Input

//*********************************************************** Check Input ****************************************************************************
//PARAMETER
//8 bit  [I]: Input selector.     1: Input1, 2: Input2, 3: Input3, 4: Input4, 5: Input5, 6:Switch1, 7:Switch2
//8 bit  [I]: Input control mode. 0: Check if the input value is '0' (without debounce),
//                                1: Check if the input value is '0' (with debounce),
//                                2: Check if the input value is '0' (with debounce) and stays at '0' for more than 2 seconds.
//                                3: Check if the input value is '0' (with debounce) and stays at '0' for more than 2 seconds with beep.
//16 bit [I]: Jump address if input is '0'.
//16 bit [I]: Jump address if input stays at '0' for more that 2 seconds.
#define CHECK_INPUT_0 31
#define COMMAND.IO.CHECK_INPUT_0 "Test if Input = '0'"(In8_1(1:Input1, 2:Input2, 3:Input3, 4:Input4, 5:Input5, 6:Switch1, 7:Switch2)"Input to be checked", In8_2(0:Check if input is '0', 1:Check if input is '0' with debounce, 2:Check if input is '0' and if it stays '0' for more than 2 seconds, 3:Check if input is '1' and if it stays '1' for more than 2 seconds with beep)"Input control mode. 0: Return the input value, 1: Check if the input value is '0' (with debounce), 2: Check if the input value is '0' (with debounce) and stays at '0' for more than 2 seconds, 3: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds with beep.", J16_1"Jump target state if input is 0",J16_2"Jump target state if input stays at 0 for more that 2 seconds"){Check input In8_1<br>Type of control=In8_2<br>if IN In8_1=0<br>Jump to J16_1<br>if IN In8_1=0 for more 2 seconds<br>Jump to J16_2}-JUMP.Input0

//*************************************************** Check numer of switch pressure *****************************************************************
//PARAMETER
//8 bit  [I]: Input selector.     1: Input1, 2: Input2, 3: Input3, 4: Input4, 5: Input5, 6:Switch1, 7:Switch2
//8 bit  [R]: Index of Register where store number of switch pressure
//8 bit  [I]: Number of maximum switch pressure. After this value, reset number of pressure
#define CHECK_INPUT_PRESSURE_1 39
#define COMMAND.IO.CHECK_INPUT_PRESSURE_1 "Number of key presses from 0 to 1"(In8_1(1:Input1, 2:Input2, 3:Input3, 4:Input4, 5:Input5, 6:Switch1, 7:Switch2)"Input to be checked", RIn_1"Numeric variable to store number of key presses", In8_2"Maximum number of key presses"){Check input In8_1<br>RIn_1=Presses number<br>Max pressese=In8_2}-OUTPUT.Input

//*************************************************** Check numer of switch pressure *****************************************************************
//PARAMETER
//8 bit  [I]: Input selector.     1: Input1, 2: Input2, 3: Input3, 4: Input4, 5: Input5, 6:Switch1, 7:Switch2
//8 bit  [R]: Index of Register where store number of switch pressure
//8 bit  [I]: Number of maximum switch pressure. After this value, reset number of pressure
#define CHECK_INPUT_PRESSURE_0 40
#define COMMAND.IO.CHECK_INPUT_PRESSURE_0 "Number of key presses from 1 to 0"(In8_1(1:Input1, 2:Input2, 3:Input3, 4:Input4, 5:Input5, 6:Switch1, 7:Switch2)"Input to be checked", RIn_1"Numeric variable to store number of key presses", In8_2"Maximum number of key presses"){Check input In8_1<br>RIn_1=Presses number<br>Max presses=In8_2}-OUTPUT.Input0

//*********************************************************** Check Input ****************************************************************************
//PARAMETER
//8 bit  [R]: Input selector register. 1: Input1, 2: Input2, 3: Input3, 4: Input4, 5: Input5, 6:Switch1, 7:Switch2
//8 bit  [I]: Input control mode. 0: Return the input value,
//                                1: Check if the input value is '1' (with debounce),
//                                2: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds.
//                                3: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds with beep.
//8 bit  [R]: Index of the destination register where the input value will be stored.
//            Register will be set to the input value ('0' or '1') when the Input control mode is set to '0' or '1'.
//            Register will be set to '2' if the the input stays at '1' for more than 2 seconds when the Input control mode is set to '2' or '3'.
#define CHECK_INPUT_REGISTER 32
#define COMMAND.IO.CHECK_INPUT_REGISTER "Save Input value a variable"(RIn_1"Input selector. 1: Input1, 2: Input2, 3: Input3, 4: Input4, 5: Input5, 6: Switch1, 7: Switch2",In8_1(0:Return the input value, 1:Check if input is '1' with debounce, 2:Check if input is '1' and if it stays at '1' for more than 2 seconds, 2:Check if input is '1' and if it stays at '1' for more than 2 seconds with beep)"Input control mode. 0: Return the input value, 1: Check if the input value is '1' (with debounce), 2: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds, 3: Check if the input value is '1' (with debounce) and stays at '1' for more than 2 seconds with beep.",ROut_1"Destination variable where the input value will be stored. The variable will be set to the input value ('0' or '1') when the Input control mode is set to '0' or '1'. The variable will be set to '2' if the the input stays at '1' for more than 2 seconds when the Input control mode is set to '2' or '3'."){Check input RIn_1<br>Type of control=In8_1<br>ROut_1=input value}-JUMP.Input

//*********************************************************** Set Output *****************************************************************************
//PARAMETER
//8 bit  [I]: Output selector.    1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5
//            The selected output will be set to '1'.
#define SET_OUT 33
#define COMMAND.IO.SET_OUT "Set Output to '1'"(In8_1(1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5, 6: Alim CTRL)"Select the Output line to set"){OUT In8_1=1}-OUTPUT.OutputOn

//********************************************************* Reset Output *****************************************************************************
//PARAMETER
//8 bit  [I]: Output selector.    1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5
//            The selected output will be reset to '0'.
#define RESET_OUT 34
#define COMMAND.IO.RESET_OUT "Reset Output to '0'"(In8_1(1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5, 6: Alim CTRL)"Select the Output line to reset"){OUT In8_1=0}-OUTPUT.OutputOff

//*********************************************************** Set Output *****************************************************************************
//PARAMETER
//8 bit  [R]: Index of the Output selector register. 1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5
//            The selected output will be set to '1'.
#define SET_OUT_REGISTER 35
#define COMMAND.IO.SET_OUT_REGISTER "Set Output to '1' (Variable selector)"(RIn_1"Output selector variable. 1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5. The selected output will be set to '1'."){OUT RIn_1=1}-OUTPUT.OutputOn

//********************************************************* Reset Output *****************************************************************************
//PARAMETER
//8 bit  [R]: Index of the Output selector register. 1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5
//            The selected output will be reset to '0'.
#define RESET_OUT_REGISTER 36
#define COMMAND.IO.RESET_OUT_REGISTER "Reset Output to '0' (Variable selector)"(RIn_1"Output selector variable. 1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5. The selected output will be reset to '0'."){OUT RIn_1=0}-OUTPUT.OutputOff

//********************************************************* Analog Input *****************************************************************************
//PARAMETER
//8 bit  [I]: Analog Input selector. 1: Input1, 2: Input2, 3: Input3, 4: Input4, 5: Input5
//8 bit  [I]: Input Range selector: 0: 0-12V  input range (resolution = 17,9mV)
//            						1: 0-3.3V input range (resolution = 3,2mV)
//8 bit  [R]: Index of the destination register where the Analog value will be stored (in mV)
#define ANALOG_INPUT 37
#define COMMAND.IO.ANALOG_INPUT "Read Analog Input value."(In8_1(1:Input1, 2:Input2, 3:Input3, 4:Input4, 5:Input5)"Analog Input selector",In8_2(0: 0-12V input range, 1: 0-3.3V input range)"Input Range selector. 0: 0-12V analog input range (resolution 17.9mV), 1: 0-3.3V analog input range (3.2mV resolution)",ROut_1"Destination variable where the Analog value will be stored (in mV). The value is in mV."){Read analog input In8_1<br>Type of control=In8_2<br>ROut_1= analog input In8_1}-OUTPUT.AnalogInput

//*********************************************************** Set Output *****************************************************************************
//PARAMETER
//8 bit  [I]: Output selector.    1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5
//8 bit  [R]: Index of register were store to output
//            The selected output will be set to value of index of Registro.
#define SET_OUT_TO_VALUE 38
#define COMMAND.IO.SET_OUT_TO_VALUE "Set digital Output to variable value"(In8_1(1: Output1, 2: Output2, 3: Output3, 4: Output4, 5: Output5, 6: Alim CTRL)"Select the Output line to set", RIn_1"Numerical variable to store to output"){OUT In8_1=RIn_1}-OUTPUT.SetOutput

//----------------------------------------------------------------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------ G S M   F U N C T I O N S -------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------

//********************************************************* Turn ON GSM ******************************************************************************
//PARAMETER
//8 bit  [R]: Index of the register where the GSM initialization result will be stored:
//            '0' stored in the register if initialization is OK
//            '1' stored in the register if there is no GSM signal (cannot connect to the GSM central)
//            '2' stored in the register if there are problems to communicate with GSM module
#define GSM_ON 50
#define COMMAND.GSM.GSM_ON "Turn GSM ON"(ROut_1"GSM initialization status variable. '0' all OK, '1' no GSM signal, '2' problem to communicate with GSM module"){ROut_1=State of the GSM<br>0 all OK<br>1 no GSM signal<br>2 problem to communicate with GSM module}-OUTPUT.GSMOn

//********************************************************* Turn OFF GSM *****************************************************************************
#define GSM_OFF 51
#define COMMAND.GSM.GSM_OFF "Turn GSM OFF"()-OUTPUT.GSMOff

//*********************************************************** Send SMS *******************************************************************************
//PARAMETER
//8 bit  [I]: SMS type. 0: Standard SMS, 1: Flash SMS
//16 bit [M]: Memory address where the destination phone number is stored
//16 bit [M]: Memory address where the text message to send is stored
#define SEND_SMS 52
#define COMMAND.GSM.SEND_SMS "Send SMS"(In8_1(0:Standard SMS, 1:Flash SMS)"SMS type: 0=Standard SMS, 1=Flash SMS",MemIn_1"Destination phone number",MemIn_2"Text message to send"){SMS Type=In8_1<br>Phone Number=[MemIn_1]<br>Text=[MemIn_2]}-OUTPUT.SendSMS

//*********************************************************** Read SMS *******************************************************************************
//PARAMETER
//8 bit  [R]: Index of the register where the position of the SMS to read is stored
//16 bit [M]: Memory address where the read SMS will be stored
//8 bit  [R]: Index of the register where the SMS state (0=read, 1=unread) will be stored
//16 bit [M]: Memory address where the SMS sender number will be stored
//8 bit  [I]: Type of read. 0: read the SMS and exit, 1: read the SMS and exit, but wait indefinitely for the arrival of an SMS
//8 bit  [R]: Index of the register where the state of reading will be stored. 0=message present, 1=message not present
#define READ_SMS 53
#define COMMAND.GSM.READ_SMS "Read SMS"(RIn_1"Position of the SMS to read",MemOut_1"Destination string of the read SMS",ROut_1"SMS state variable (0=read, 1=unread)",MemOut_2"SMS sender number destination string",In8_1(0:read and exit, 1:wait SMS)"Type of read. 0: read the SMS and exit, 1: read the SMS and exit, but wait indefinitely for the arrival of an SMS",ROut_2"State of reading. 0=message present, 1=message not present"){SMS Position=RIn_1<br>SMS Read=[MemOut_1]<br>SMS State=ROut_1<br>Phone Number=[MemOut_2]<br>Read Type=In8_1<br>Reading State=ROut_2}-JUMP.ReadSMS

//#define COMMAND.GSM.READ_SMS "Read SMS"-JUMP.ReadSMS
//#define COMMAND.GSM.READ_SMS.PARAMS_1 RIn_1"Position of the SMS to read"
//#define COMMAND.GSM.READ_SMS.PARAMS_2 MemOut_1"Destination string of the read SMS"
//#define COMMAND.GSM.READ_SMS.PARAMS_3 ROut_1"SMS state variable (0=read, 1=unread)"
//#define COMMAND.GSM.READ_SMS.PARAMS_4 MemOut_2"SMS sender number destination string"
//#define COMMAND.GSM.READ_SMS.PARAMS_5 In8_1"Type of read. 0: read the SMS and exit, 1: read the SMS and exit, but wait indefinitely for the arrival of an SMS"
//#define COMMAND.GSM.READ_SMS.PARAMS_5_VALUES {0:"read and exit", 1:"wait SMS"}
//#define COMMAND.GSM.READ_SMS.PARAMS_6 ROut_2"State of reading. 0=message present, 1=message not present"
//#define COMMAND.GSM.READ_SMS.SHORT {SMS Position=RIn_1<br>SMS Read=[MemOut_1]<br>SMS State=ROut_1<br>Phone Number=[MemOut_2]<br>Read Type=In8_1<br>Reading State=ROut_2}
// TODO: SCIPIO What about a definition like that? It would be much easier to maintaining/modifying it

//*********************************************************** Delete SMS *****************************************************************************
//PARAMETER
//8 bit  [R]: Index of the register where the SMS to delete position is stored
//8 bit  [R]: Index of the register where the state of deletion will be stored. 0:message deleted, 1:message not deleted
#define DELETE_SMS 54
#define COMMAND.GSM.DELETE_SMS "Delete SMS"(RIn_1"Position of the SMS to delete",ROut_1"Deletion status. 0:message deleted, 1:message not deleted"){Delete message at address RIn_1<br>ROut_1=Delete state}-OUTPUT.DeleteSMS

//*********************************************************** Send Call ******************************************************************************
//PARAMETER
//16 bit [I]: Number of seconds to wait for the answer
//16 bit [I]: Number of seconds to keep the call active
//8 bit  [I]: Max number of tentative calls if no answer
//16 bit [M]: Memory address where the number to call is stored
//8 bit  [R]:  Index of the register where the state of the call is stored. 0: no answer, 1: call ended after the number of seconds requested, 2: call remotely ended
#define SEND_CALL 55
#define COMMAND.GSM.SEND_CALL "Send call"(In16_1"Number of seconds to wait for the answer",In16_1"Number of seconds to keep the call active",In8_1"Max number of tentative calls if no answer",MemIn_1"Number to call string",ROut_1"State of the call. 0: no answer, 1: call ended after the number of seconds requested, 2: call remotely ended"){Wait max In16_1 seconds for an answer<br>Call active for In16_2 seconds<br>Recall max tentatives In8_1<br>Number to call=[MemIn_1]<br>ROut_1=State of the call}-OUTPUT.SendCall

//*********************************************************** Wait Call ******************************************************************************
//PARAMETER
//16 bit [I]: Number of seconds to wait for an incoming call
//16 bit [I]: Number of seconds to keep the call active after responding
//16 bit [M]: Memory address where the number of the incoming call will be stored
//8 bit  [R]: Index of the register where the state of the incoming call is stored. 0: no call received, 1: call ended after the number of seconds requested, 2: call remotely ended
#define WAIT_CALL 56
#define COMMAND.GSM.WAIT_CALL "Wait for incoming call"(In16_1"Number of seconds to wait for an incoming call",In16_2"Number of seconds to keep the call active after responding",MemOut_1"Destination string for the caller number",ROut_1"Incoming call status. 0: no call received, 1: call ended after the number of seconds requested, 2: call remotely ended"){Wait incoming call for max In16_1 seconds<br>Call active for In16_2 seconds<br>[MemOut_1]=Caller number<br>ROut_1=Satte of the call}-JUMP.WaitCall

//***************************** Control call state and return state and phone number of incoming call ************************************************
//PARAMETER
//8 bit  [R]: Index of the register where the call state will be stored. 0: existing incoming call, 1:no incoming call
//16 bit [M]: Memory address where the caller phone number will be stored
#define CALL_STATE 57
#define COMMAND.GSM.CALL_STATE "Check incoming call status"(RIn_1"Call status. 0: existing incoming call, 1:no incoming call",MemOut_1"Destination string for the caller number"){RIn_1=Call state<br>[MemOut_1]=Caller number}-JUMP.CallState

//*************************************************** Reply to incoming call *************************************************************************
#define CALL_REPLY 58
#define COMMAND.GSM.CALL_REPLY "Answer incoming call"()-OUTPUT.ReplyCall

//****************************************************** Close active call ***************************************************************************
#define CALL_CLOSE 59
#define COMMAND.GSM.CALL_CLOSE "Close incoming call"()-OUTPUT.CloseCall

//****************************************************** Automatic call answer ***********************************************************************
//PARAMETER
//16 bit [I]: Number of rings to wait before answering. 0: Disable automatic answering
#define AUTOMATIC_CALL_REPLY 60
#define COMMAND.GSM.AUTOMATIC_CALL_REPLY "Automatic call answering"(In16_1"Number of rings to wait before answering. 0: Disable automatic answering"){Automatic call answering after<br>In16_1 rings.<br>0=Disable automatic answering.}-OUTPUT.AutomaticCallReply

//****************************************************** Enable auto check GSM connection ************************************************************
#define ENABLE_GSM_AUTO_CHECK 61
#define COMMAND.GSM.ENABLE_GSM_AUTO_CHECK "Automatic check if GSM is connect"(){Automatic check every 60 sec. if GSM is connect.<br>If no connect, try to reconnect.}-OUTPUT.EnableGSMAutoCheck

//****************************************************** Disable auto check GSM connection ***********************************************************
#define DISABLE_GSM_AUTO_CHECK 62
#define COMMAND.GSM.DISABLE_GSM_AUTO_CHECK "Disable automatic check if GSM is connect"(){}-OUTPUT.DisableGSMAutoCheck


//----------------------------------------------------------------------------------------------------------------------------------------------------

//----------------------------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------ S T R I N G / R E G I S T E R   F U N C T I O N S -------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------

//*************************************************** Store value to register *********************************************************************
//PARAMETER
//8 bit  [R]: Index of the register where the value will be stored
//16 bit [I]: Constant value to be stored in the register
#define LOAD_CONST_REGISTER 83
#define COMMAND.STRING.LOAD_CONST_REGISTER "Store constant to numeric variable"(ROut_1"Destination variable",In16_1"Constant value"){ROut_1=In16_1}-OUTPUT.ConstantToRegister

//*********************************************************** Copy String ****************************************************************************
//PARAMETER
//16 bit [M]: Memory address where source string 1 is stored
//16 bit [M]: Memory address where source string 2 is stored
//16 bit [M]: Memory address where the merged strings will be stored
#define MERGE_STRING 70
#define COMMAND.STRING.MERGE_STRING "Merge two Strings"(MemIn_1"First String",MemIn_2"Second String",MemOut_1"Merged String"){1st string=[MemIn_1]<br>2nd string=[MemIn_2]<br>Merged string=[MemOut_1]}-OUTPUT.MergeString

//*********************************************************** Integer to String **********************************************************************
//PARAMETER
//8 bit  [R]: Index of the register where the integer value to convert is stored
//16 bit [M]: Memory address where the converted string will be stored
#define INT_TO_STRING 71
#define COMMAND.STRING.INT_TO_STRING "Convert Integer to String"(RIn_1"Integer value to convert",MemOut_1"Converted String"){[MemOut_1]=RIn_1}-OUTPUT.IntToString

//************************************************** String to integer *******************************************************************************
//PARAMETER
//16 bit [M]: Flash memory base address where read the value to convert
//8 bit  [R]: Index of the register were store converted value
#define STRING_TO_INT 88
#define COMMAND.STRING.STRING_TO_INT "Convert string to int"(MemIn_1"String were read the value to convert",RIn_1"Numerical variable to store converted value"){RIn_1=Integer of [MemIn_1]}-OUTPUT.StringToInt

//*********************************************************** Copy String ****************************************************************************
//PARAMETER
//16 bit [M]: Memory address where the source string is stored
//16 bit [M]: Memory address where the copied string will be stored
#define COPY_STRING 72
#define COMMAND.STRING.COPY_STRING "Copy String"(MemIn_1"Source String",MemOut_1"Destination String"){Src string=[MemIn_1]<br>Dst string=[MemOut_1]}-OUTPUT.CopyString

//*********************************************************** Find String ****************************************************************************
//PARAMETER
//16 bit [M]: Memory address where the source string is stored
//16 bit [M]: Memory address where the sub-string to find is stored
//8 bit  [R]: Index of the register where the position of the found string will be stored
//8 bit  [R]: Index of the register where the result of test will be stored. 0: string found, 1: string not found
//8 bit  [I]: Type of search. 0: test if the 2 string are equal. 1: test if string2 is included in string2 and return the position
#define FIND_STRING 73
#define COMMAND.STRING.FIND_STRING "Find String"(MemIn_1"Source String",MemIn_2"Sub-string to find",ROut_1"Returning position of the Sub-string (if found)",ROut_2"Match result. 0: sub-string found, 1: sub-string not found",In8_1(0:Test string equality,1: Search sub-string into string)"Type of search. 0: test if the 2 string are equal. 1: test if string2 is included in string2 and return the position"){Source string=[MemIn_1]<br>Sub-string to find=[MemIn_2]<br>ROut_1=Position of substring<br>ROut_2=Result of test. 0=Sub-string found, 1=Sub-string not found<br>Type of search=In8_1}-OUTPUT.FindString
#define FIND_STRING_JUMP 73
#define COMMAND.STRING.FIND_STRING_JUMP "Find String"(MemIn_1"Source String",MemIn_2"Sub-string to find",ROut_1"Returning position of the Sub-string (if found)",ROut_2"Match result. 0:Sub-string found, 1: Sub-string not found",In8_1(0:Test string equality,1: Search sub-string into string)"Type of search. 0: test if the 2 string are equal. 1: test if string2 is included in string1 and return the position"){Source string=[MemIn_1]<br>Sub-string to find=[MemIn_2]<br>ROut_1=Position of substring<br>ROut_2=Result of test. 0=Sub-string found, 1=Sub-string not found<br>Type of search=In8_1}-JUMP.FindString

//******************************************************* Add character to String ********************************************************************
//PARAMETER
//16 bit [M]: Memory address where the source string is stored
//8 bit  [I]: Character in decimal value of ascii to insert
//8 bit  [I]: Position to insert character (from right)
#define ADD_CHARACTER_TO_STRING 76
#define COMMAND.STRING.ADD_CHARACTER_TO_STRING "Add character to String"(MemIn_1"Source String",In8_1"Character to add (decimal value of ascii)",In8_2"Position to insert (from right)"){Source string=[MemIn_1]<br>Character to add=In8_1<br>Position to insert=In8_2}-OUTPUT.AddCharacter

//*********************************************************** Cut String *****************************************************************************
//PARAMETER
//16 bit [M]: Memory address where the source string is stored
//8 bit  [R]: Index of the register where the cutting start position is stored
//8 bit  [R]: Index of the register where the number of characters to cut is stored
//16 bit [M]: Memory address where the cut string will be stored
#define CUT_STRING 74
#define COMMAND.STRING.CUT_STRING "Cut String"(MemIn_1"Source String",RIn_1"Cut starting position",RIn_2"Number of characters to cut",MemOut_1"Destination String"){Source string=[MemIn_1]<br>Start position to cut=RIn_1<br>Character to cut=RIn_2<br>[MemOut_1]=String cutted}-OUTPUT.CutString

//*********************************************************** Len String *****************************************************************************
//PARAMETER
//16 bit [M]: Memory address where
//8 bit  [R]: Index of the register where store len of string
#define LEN_STRING 75
#define COMMAND.STRING.LEN_STRING "Len String"(MemIn_1"Source String",RIn_1"Numeric variable were store len of string"){Source string=[MemIn_1]<br>Len=RIn_1}-OUTPUT.LenString


//************************************************* Load Register value from Flash with immediate address ********************************************
//PARAMETER
//8 bit  [R]: Index of the destination register where the value will be stored
//16 bit [M]: Flash memory address where value is stored
#define LOAD_MEM_REGISTER_DIRECT 80
#define COMMAND.STRING.LOAD_MEM_REGISTER_DIRECT "Load numeric value from flash"(ROut_1"Destination variable",RegMemIn_1"Flash variable name"){ROut_1=[RegMemIn_1]}-OUTPUT.LoadRegisterFlashByRegister

//************************************************** Store Register value to Flash with immediate address ********************************************
//PARAMETER
//16 bit [M]: Flash memory address where the register value will be stored
//8 bit  [R]: Index of the register where the source value is stored
#define STORE_MEM_REGISTER_DIRECT 82
#define COMMAND.STRING.STORE_MEM_REGISTER_DIRECT "Store numeric value to flash"(RegMemOut_1"Flash variable name",RIn_1"Source variable"){[RegMemOut_1]=RIn_1}-OUTPUT.StoreRegisterFlashByRegister

//*************************************************** Store value to register *********************************************************************
//PARAMETER
//8 bit  [R]: Index of the register where the value will be stored
//8 bit  [R]: Index of the register where read value to copy
#define COPY_REGISTER_TO_REGISTER 89
#define COMMAND.STRING.COPY_REGISTER_TO_REGISTER "Copy numeric variable to another numeric variable"(ROut_1"Destination variable",RIn_1"Varable to copy"){ROut_1=RIn_1}-OUTPUT.CopyRegisterToRegister

//************************************************* Load value to register from vector ***************************************************************
//PARAMETER
//8 bit  [R]: Index of the register where the value will be stored
//16 bit [M]: Flash memory base address where the values are stored
//8 bit  [R]: Index of the register containing the vector index
#define LOAD_VECTOR_REGISTER 84
#define COMMAND.STRING.LOAD_VECTOR_REGISTER "Load Vector value to numeric variable"(ROut_1"Destination variable",RegMemVectIn_1"Source Vector name",RIn_1"Vector index"){ROut_1=[RegMemVectIn_1(RIn_1)]}-OUTPUT.LoadRegisterFlashByRegister

//************************************************* Load value to register from vector ***************************************************************
//PARAMETER
//8 bit  [R]: Index of the register where the value will be stored
//16 bit [M]: Flash memory base address where the values are stored
//8 bit  [R]: Index of the register containing the vector index
#define LOAD_VECTOR_REGISTER_STRING 84
#define COMMAND.STRING.LOAD_VECTOR_REGISTER_STRING "Load String value to numeric variable"(ROut_1"Destination variable",MemIn_1"Source Vector name",RIn_1"Vector index"){ROut_1=[MemIn_1(RIn_1)]}-OUTPUT.LoadRegisterFlashByRegister


//************************************************** Store resgister value to vector *****************************************************************
//PARAMETER
//16 bit [M]: Flash memory base address where the value will be stored
//8 bit  [R]: Index of the register containing the value to be stored
//8 bit  [R]: Index of the register containing the vector index
#define STORE_VECTOR_REGISTER 85
#define COMMAND.STRING.STORE_VECTOR_REGISTER "Store numeric variable to Vector"(RegMemVectOut_1"Destination Vector name",RIn_1"Source variable",RIn_2"Vector index"){[RegMemVectOut_1(RIn_2)]=RIn_1}-OUTPUT.StoreRegisterFlashByRegister

//************************************************* Load vector value to string **********************************************************************
//PARAMETER
//16 bit [M]: Memory address where the string will be stored
//16 bit [M]: Flash memory base address where the strings are stored
//8 bit  [R]: Index of the register containing the vector index
#define LOAD_VECTOR_STRING 86
#define COMMAND.STRING.LOAD_VECTOR_STRING "Load Strings-vector string to string"(MemOut_1"Destination String",StringMemVectIn_1"Source Strings-vector name",RIn_1"Vector index"){MemOut_1=[StringMemVectIn_1(RIn_1)]}-OUTPUT.LoadRegisterFlashByRegister

//************************************************** Store string to vector **************************************************************************
//PARAMETER
//16 bit [M]: Flash memory base address where the string will be stored
//16 bit [M]: Memory address containing the string to be stored
//8 bit  [R]: Index of the register containing the vector index
#define STORE_VECTOR_STRING 87
#define COMMAND.STRING.STORE_VECTOR_STRING "Store string to Strings-vector"(StringMemVectOut_1"Destination Strings-vector name",MemIn_1"Source String",RIn_1"Vector index"){[StringMemVectOut_1(RIn_1)]=MemIn_1}-OUTPUT.StoreRegisterFlashByRegister


//----------------------------------------------------------------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------- A R I T M E T I C / L O G I C   F U N C T I O N S ----------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------

//************************************************************ Sum ***********************************************************************************
//PARAMETER
//8 bit  [R]: Index of the register containing the 1st addend
//8 bit  [R]: Index of the register containing the 2nd addend
//8 bit  [R]: Index of the register where the sum result will be stored
//8 bit  [R]: Index of the register where the state of the sum will be stored. 0: no overflow, 1: overflow
#define SUM_REGISTER 100
#define COMMAND.ARITHMETIC.SUM_REGISTER "Sum two variables"(RIn_1"1st Addend",RIn_2"2nd Addend",ROut_1"Sum destination Variable",ROut_2"Overflow flag. 0: no overflow, 1: overflow"){ROut_1=RIn_1+RIn_2<br>Overflow=ROut_2}-OUTPUT.Sum

//********************************************************* Subtraction ******************************************************************************
//PARAMETER
//8 bit  [R]: Index of the register containing the minuend
//8 bit  [R]: Index of the register containing the subtrahend
//8 bit  [R]: Index of the register where the subtract result will be stored
//8 bit  [R]: Index of the register where the state of the subtract will be stored. 0: no overflow, 1: overflow
#define SUB_REGISTER 101
#define COMMAND.ARITHMETIC.SUB_REGISTER "Subtract two variables"(RIn_1"Minuend",RIn_2"Subtrahend",ROut_1"Difference destination Variable",ROut_2"Overflow flag. 0: no overflow, 1: overflow"){ROut_1=RIn_1-RIn_2<br>Overflow=ROut_2}-OUTPUT.Sub

//********************************************************** Division ********************************************************************************
//PARAMETER
//8 bit  [R]: Index of the register containing the dividend
//8 bit  [R]: Index of the register containing the divisor
//8 bit  [R]: Index of the register where the division result will be stored
//8 bit  [R]: Index of the register where the state of the subtract will be stored. 0: no overflow, 1: overflow
#define DIV_REGISTER 102
#define COMMAND.ARITHMETIC.DIV_REGISTER "Divide two Variables"(RIn_1"Dividend",RIn_2"Divisor",ROut_1"Quotient destination Variable",ROut_2"Overflow flag. 0: no overflow, 1: overflow"){ROut_1=RIn_1\RIn_2<br>Overflow=ROut_2}-OUTPUT.Div

//******************************************************** Multiplication ****************************************************************************
//PARAMETER
//8 bit  [R]: Index of the register containing the 1st factor
//8 bit  [R]: Index of the register containing the 2nd factor
//8 bit  [R]: Index of the register where the multiplication result will be stored
//8 bit  [R]: Index of the register where the state of the subtract will be stored. 0: no overflow, 1: overflow
#define MUL_REGISTER 103
#define COMMAND.ARITHMETIC.MUL_REGISTER "Multiply two Variables"(RIn_1"1st Factor",RIn_2"2nd Factor",ROut_1"Product destination Variable",ROut_2"Overflow flag. 0: no overflow, 1: overflow"){ROut_1=RIn_1xRIn_2<br>Overflow=ROut_2}-OUTPUT.Multiply

//******************************************************** OR ****************************************************************************************
//PARAMETER
//8 bit  [R]: Index of the register containing the 1st value
//8 bit  [R]: Index of the register containing the 2nd value
//8 bit  [R]: Index of the register where the OR result will be stored
#define OR_REGISTER 104
#define COMMAND.ARITHMETIC.OR_REGISTER "OR two Variables"(RIn_1"1st Value",RIn_2"2nd Value",ROut_1"OR Destination Variable"){ROut_1=RIn_1&RIn_2}-OUTPUT.OR

//******************************************************** AND ***************************************************************************************
//PARAMETER
//8 bit  [R]: Index of the register containing the 1st value
//8 bit  [R]: Index of the register containing the 2nd value
//8 bit  [R]: Index of the register where the AND result will be stored
#define AND_REGISTER 105
#define COMMAND.ARITHMETIC.AND_REGISTER "AND two Variables"(RIn_1"1st Value",RIn_2"2nd Value",ROut_1"AND Destination Variable"){ROut_1=RIn_1&RIn_2}-OUTPUT.AND

//----------------------------------------------------------------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------------------------------------------------------------------
//---------------------------------------------------- T E S T   F U N C T I O N S -------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------

//*************************************************** Test if 2 register is equal ********************************************************************
//PARAMETER
//8 bit  [R]: Index of the register containing the 1st value
//8 bit  [R]: Index of the register containing the 2nd value
//16 bit [I]: Jump target address. Jump only if the 2 registers are equal
#define IF_EQUAL 120
#define COMMAND.TEST.IF_EQUAL "Test if two Variables are equal"(RIn_1"1st Value",RIn_2"2nd Value",J16_1"Jump target State"){if RIn_1=RIn_2<br>Jump to J16_1}-JUMP.Equal

//******************************************* Test if register 1 is greater of register 2 ************************************************************
//PARAMETER
//8 bit  [R]: Index of the register containing the 1st value
//8 bit  [R]: Index of the register containing the 2nd value
//16 bit [I]: Jump target address. Jump only if the 1st register is bigger than the 2nd
#define IF_GREATER 121
#define COMMAND.TEST.IF_GREATER "Test if 1st Variable > 2nd Variable"(RIn_1"1st Value",RIn_2"2nd Value",J16_1"Jump target State"){if RIn_1>RIn_2<br>Jump to J16_1}-JUMP.Greater

//******************************************** Test if register 1 is minor of register 2 *************************************************************
//PARAMETER
//8 bit  [R]: Index of the register containing the 1st value
//8 bit  [R]: Index of the register containing the 2nd value
//16 bit [I]: Jump target address. Jump only if the 1st register is smaller than the 2nd
#define IF_MINOR 122
#define COMMAND.TEST.IF_MINOR "Test if 1st Variable < 2nd Variable"(RIn_1"1st Value",RIn_2"2nd Value",J16_1"Jump target State"){if RIn_1&lt;RIn_2<br>Jump to J16_1}-JUMP.Smaller


//*************************************************** Test if 2 register is equal ********************************************************************
//PARAMETER
//8 bit  [R]: Index of the register containing the 1st value
//16 bit [I]: Costant
//16 bit [I]: Jump target address. Jump only if the 1st register equal to costant
#define IF_EQUAL_DIRECT 123
#define COMMAND.TEST.IF_EQUAL_DIRECT "Test if Variable = Costant"(RIn_1"Numerical variable",In16_1"Costant",J16_1"Jump target State"){if RIn_1=In16_1<br>Jump to J16_1}-JUMP.Equal

//******************************************* Test if register 1 is greater of register 2 ************************************************************
//PARAMETER
//8 bit  [R]: Index of the register containing the 1st value
//16 bit [I]: Costant
//16 bit [I]: Jump target address. Jump only if the 1st register is bigger than costant
#define IF_GREATER_DIRECT 124
#define COMMAND.TEST.IF_GREATER_DIRECT "Test if Variable > Costant"(RIn_1"Numerical variable",In16_1"Costant",J16_1"Jump target State"){if RIn_1>In16_1<br>Jump to J16_1}-JUMP.Greater

//******************************************** Test if register 1 is minor of register 2 *************************************************************
//PARAMETER
//8 bit  [R]: Index of the register containing the 1st value
//16 bit [I]: Costant
//16 bit [I]: Jump target address. Jump only if the 1st register is smaller than costant
#define IF_MINOR_DIRECT 125
#define COMMAND.TEST.IF_MINOR_DIRECT "Test if Variable < Costant"(RIn_1"Numerical variable",In16_1"Costant",J16_1"Jump target State"){if RIn_1&lt;In16_1<br>Jump to J16_1}-JUMP.Smaller

//----------------------------------------------------------------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------- U S B   F U N C T I O N S -----------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------

//****************************************************** Turn USB ON *********************************************************************************
#define USB_ON 140
#define COMMAND.USB.USB_ON "Turn USB/RS232 ON"()-OUTPUT.USBOn

//***************************************************** Turn USB OFF *********************************************************************************
#define USB_OFF 141
#define COMMAND.USB.USB_OFF "Turn USB/RS232 OFF"()-OUTPUT.USBOff

//****************************************** Sending data to USB from Stringhe register **************************************************************
//PARAMETER
//16 bit [M]: Memory address where the string is stored
#define TX_USB 142
#define COMMAND.USB.TX_USB "USB/232 send data"(MemIn_1"String to send"){String to send=[MemIn_1]}-OUTPUT.USBSend

//************************************* Receive data from USB and store to Stringhe register *********************************************************
//PARAMETER
//16 bit [M]: Memory address where the received string will be stored
//8 bit  [R]: Index of the register containing the inactivity timeout (in ms). 0: no timeout
//8 bit  [R]: Index of the register containing the terminator character (when received the transmission is closed)
#define RX_USB 143
#define COMMAND.USB.RX_USB "USB/232 receive data (OBSOLETE)"(MemIn_1"Destination String",RIn_1"Inactivity timeout (ms). 0: no timeout",RIn_2"Terminator character (if value is different of 0, when received shut-down the transfer)"){[MemIn_1]=String<br>Inactivity timeout=RIn_1<br>Char to exit=RIn_2}-OUTPUT.USBReceive

//************************************* Receive data from USB and store to Stringhe register *********************************************************
//PARAMETER
//16 bit [M]: Memory address where the received string will be stored
//8 bit  [R]: Index of the register containing the inactivity timeout (in ms). 0: no timeout
//8 bit  [R]: Number of characters befour exit of routine. If rhis value is 0, not consider this parameter
//8 bit  [R]: Index of the register containing the terminator character (when received the transmission is closed)
#define RX_USB_CHARACTERS 144
#define COMMAND.USB.RX_USB_CHARACTERS "USB/232 receive data"(MemIn_1"Destination String",RIn_1"Inactivity timeout (ms). 0: no timeout", In8_1 "Number of characters befour exit of routine. If rhis value is 0, not consider this parameter", RIn_2"Terminator character (if value is different of 0, when received shut-down the transfer)"){[MemIn_1]=String<br>Inactivity timeout=RIn_1<br>Number of character for exit=In8_1<br>Char to exit=RIn_2}-OUTPUT.USBReceive


//----------------------------------------------------------------------------------------------------------------------------------------------------



//----------------------------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------- U A R T   F U N C T I O N S ---------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------

//****************************************************** Turn UART1 ON *********************************************************************************
//PARAMETER
//8 bit  [I]: speed selector. 
//			  0=2400, 
//			  1=4800, 
//			  2=9600
//			  3=14400
//			  4=19200
//			  5=28800
//			  6=38400
//			  7=57600
//			  8=76800
//			  9=115200
#define UART1_ON 145
#define COMMAND.UART.UART1_ON "Turn UART1 ON"(In8_1(0: 2400bps,1: 4800bps,2: 9600bps,3: 14400bps,4: 19200bps,5: 28800bps,6: 38400bps,7: 57600bps,8: 76800bps,9: 115200bps)"RS232 speed"){RS232 speed=In8_1}-OUTPUT.UARTOn

//***************************************************** Turn UART1 OFF *********************************************************************************
#define UART1_OFF 146
#define COMMAND.UART.UART1_OFF "Turn UART1 OFF"()-OUTPUT.UARTOff

//****************************************** Sending data to UART1 from Stringhe register **************************************************************
//PARAMETER
//16 bit [M]: Memory address where the string is stored
#define TX_UART1 147
#define COMMAND.UART.TX_UART1 "UART1 send data"(MemIn_1"String to send"){String to send=[MemIn_1]}-OUTPUT.UARTSend

//************************************* Receive data from UART1 and store to Stringhe register *********************************************************
//PARAMETER
//16 bit [M]: Memory address where the received string will be stored
//8 bit  [R]: Index of the register containing the inactivity timeout (in ms). 0: no timeout
//8 bit  [R]: Number of characters befour exit of routine. If rhis value is 0, not consider this parameter
//8 bit  [R]: Index of the register containing the terminator character (when received the transmission is closed)
#define RX_UART1 148
#define COMMAND.UART.RX_UART1 "UART1 receive data"(MemIn_1"Destination String",RIn_1"Inactivity timeout (ms). 0: no timeout", In8_1 "Number of characters befour exit of routine. If rhis value is 0, not consider this parameter", RIn_2"Terminator character (if value is different of 0, when received shut-down the transfer)"){[MemIn_1]=String<br>Inactivity timeout=RIn_1<br>Number of character for exit=In8_1<br>Char to exit=RIn_2}-OUTPUT.UARTReceive




//****************************************************** Turn UART2 ON *********************************************************************************
//PARAMETER
//8 bit  [I]: speed selector. 
//			  0=2400, 
//			  1=4800, 
//			  2=9600
//			  3=14400
//			  4=19200
//			  5=28800
//			  6=38400
//			  7=57600
//			  8=76800
//			  9=115200
#define UART2_ON 149
#define COMMAND.UART.UART2_ON "Turn UART2 ON"(In8_1(0: 2400bps,1: 4800bps,2: 9600bps,3: 14400bps,4: 19200bps,5: 28800bps,6: 38400bps,7: 57600bps,8: 76800bps,9: 115200bps)"RS232 speed"){RS232 speed=In8_1}-OUTPUT.UARTOn

//***************************************************** Turn UART2 OFF *********************************************************************************
#define UART2_OFF 141
#define COMMAND.UART.UART2_OFF "Turn UART2 OFF"()-OUTPUT.UARTOff

//****************************************** Sending data to UART2 from Stringhe register **************************************************************
//PARAMETER
//16 bit [M]: Memory address where the string is stored
#define TX_UART2 142
#define COMMAND.UART.TX_UART2 "UART2 send data"(MemIn_1"String to send"){String to send=[MemIn_1]}-OUTPUT.UARTSend

//******************************************** Sending data to UART2 from Integer value ****************************************************************
//PARAMETER
//8 bit [R]:  Variable where the value is stored
#define TX_UART2_INTEGER 150
#define COMMAND.UART.TX_UART2_INTEGER "UART2 send integer data"(RIn_1"Value to send"){Value to send=[RIn_1]}-OUTPUT.UARTSend


//********************************** Sending data to UART2 from Integer value converted in string ******************************************************
//PARAMETER
//8 bit [R]:  Variable where the value is stored
#define TX_UART2_INTEGER_STRING 152
#define COMMAND.UART.TX_UART2_INTEGER_STRING "UART2 send number conv. to string"(RIn_1"Value to send"){Value to send=[RIn_1]}-OUTPUT.UARTSend


//************************************* Receive data from UART2 and store to Stringhe register *********************************************************
//PARAMETER
//16 bit [M]: Memory address where the received string will be stored
//8 bit  [R]: Index of the register containing the inactivity timeout (in ms). 0: no timeout
//8 bit  [R]: Number of characters befour exit of routine. If rhis value is 0, not consider this parameter
//8 bit  [R]: Index of the register containing the terminator character (when received the transmission is closed)
#define RX_UART2 144
#define COMMAND.UART.RX_UART2 "UART2 receive data"(MemIn_1"Destination String",RIn_1"Inactivity timeout (ms). 0: no timeout", In8_1 "Number of characters befour exit of routine. If rhis value is 0, not consider this parameter", RIn_2"Terminator character (if value is different of 0, when received shut-down the transfer)"){[MemIn_1]=String<br>Inactivity timeout=RIn_1<br>Number of character for exit=In8_1<br>Char to exit=RIn_2}-OUTPUT.UARTReceive

//************************************* Receive data from UART2 and store to Stringhe register *********************************************************
//PARAMETER
//8 bit  [R]: Variable where the received value will be stored
//8 bit  [R]: Index of the register containing the inactivity timeout (in ms). 0: no timeout
//8 bit  [R]: Number of characters befour exit of routine. If rhis value is 0, not consider this parameter
//8 bit  [R]: Index of the register containing the terminator character (when received the transmission is closed)
#define RX_UART2_INTEGER_STRING 151
#define COMMAND.UART.RX_UART2_INTEGER_STRING "UART2 receive number conv. to string"(RIn_1"Destination variable",RIn_2"Inactivity timeout (ms). 0: no timeout", In8_1 "Number of characters befour exit of routine. If rhis value is 0, not consider this parameter", RIn_3"Terminator character (if value is different of 0, when received shut-down the transfer)"){RIn_1=Value received<br>Inactivity timeout=RIn_2<br>Number of character for exit=In8_1<br>Char to exit=RIn_3}-OUTPUT.UARTReceive

//----------------------------------------------------------------------------------------------------------------------------------------------------




//----------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------- P O W E R   D O W N   F U N C T I O N S --------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------

//*************************************** Power Down microcontroller an activate interrupt ***********************************************************
//PARAMETER
//8 bit  [I]: Input where interrupt will be enabled
//            bit 0 = IN1
//            bit 1 = IN2
//            bit 2 = NOT Used
//            bit 3 = NOT Used
//            bit 4 = IN5
//            bit 5 = NOT Used
//            bit 6 = SW1
//            bit 7 = SW2
//8 bit  [I]: Power-down type. 0: wait indefinitely for interrupt, 1: exit from sleep every 128msec.
#define PW_DOWN 160
#define COMMAND.PWDOWN.PW_DOWN "Power down"(In8_1(1: IN1,2: IN2,16: IN5,64: SW1,128: SW2,3: IN1-IN2,17: IN1-IN5,65: IN1-SW1,129: IN1-SW2,66: IN2-SW1,130: IN2-SW2,80: IN5-SW1,192: SW1-SW2,19: IN1-IN2-IN5,67: IN1-IN2-SW1,131: IN1-IN2-SW2,81: IN1-IN5-SW1,145: IN1-IN5-SW2,193: IN1-SW1-SW2,194: IN2-SW1-SW2,208: IN5-SW1-SW2)"Interrupt lines to enable",In8_2(0: wait indefinitely for interrupt,1: exit from sleep every 128ms)"Power-down type. 0: wait indefinitely for interrupt, 1: exit from sleep every 128msec."){Activated interrupt=In8_1<br>Type of power down=In8_2}-JUMP.Sleep

//----------------------------------------------------------------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------- T I M E R   F U N C T I O N ---------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------

//******************************************************** Power on timer ****************************************************************************
//8 bit  [R]: Index of the register containing the timer initial value (incremented every 10ms)
#define TIMER_ON 170
#define COMMAND.TIMER.TIMER_ON "Timer ON"(RIn_1"Initial timer counter (incremented every 10ms)"){RIn_1=Time}-OUTPUT.TimerOn

//******************************************************* Power off timer ****************************************************************************
#define TIMER_OFF 171
#define COMMAND.TIMER.TIMER_OFF "Timer OFF"()-OUTPUT.TimerOff

//----------------------------------------------------------------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------- C H E C K   B A T T E R Y -----------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------

//******************************************************** Power on timer ****************************************************************************
//8 bit  [R]: Index of the register where the battery charge value will be stored (* 10V)
#define CHECK_BATTERY 180
#define COMMAND.CHECKBATTERY.CHECK_BATTERY "Battery charge"(RIn_1"Read battery charge destination Variable"){RIn_1=Battery value}-OUTPUT.CheckBatteryValue
//----------------------------------------------------------------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------- B E E P   F U N C I O N S -----------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------
//******************************************************** Type of sound *****************************************************************************
//8 bit  [I]: Type of sound. 0:beep, 1:beep ok, 2:beep error
#define BEEP 190
#define COMMAND.SOUND.BEEP "Beep"(In8_1(0: Beep,1: Beep OK,2: Beep Error)"Type of sound"){Sound Type=In8_1}-OUTPUT.BeepIcon
//----------------------------------------------------------------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------- I 2 C   F U N C I O N S -------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------

//******************************************************** Set I2C in master mode ********************************************************************
#define I2C_MASTER 200
#define COMMAND.I2C.I2C_MASTER "Set I2C bus in Master mode"()-OUTPUT.I2CMaster

//******************************************************** Set I2C in slave mode *********************************************************************
//8 bit  [I]: Slave address
//8 bit  [R]: Index of the flag register. 1: I2C Master read a data 2: I2C Master wrote a data
#define I2C_SLAVE 201
#define COMMAND.I2C.I2C_SLAVE "Set I2C bus in Slave mode"(In8_1"Slave address (7 bit address*2)", ROut_1"I2C Status flag. 1: I2C Master read a data 2: I2C Master wrote a data"){I2C slave address=In8_1<br>RIn_1=I2C state}-OUTPUT.I2CSlave

//******************************************************** Write data in master mode *****************************************************************
//8 bit  [R]: Index of the register containing the Slave address
//8 bit  [R]: Index of the register containing the Slave register address to write
//8 bit  [R]: Index of the register containing the data to be written
#define I2C_WRITE_MASTER 202
#define COMMAND.I2C.I2C_WRITE_MASTER "Write data to I2C (Master mode)"(RIn_1"Slave address (7 bit address*2)",RIn_2"Slave register address",RIn_3"Value to write"){RIn_1=peripheral address<br>RIn_2=register address<br>RIn_3=value to write}-OUTPUT.I2CWriteMaster

//******************************************************** Read data in master mode ******************************************************************
//8 bit  [R]: Index of the register containing the Slave address
//8 bit  [R]: Index of the register containing the Slave register address to read
//8 bit  [R]: Index of the register where the read data will be stored
#define I2C_READ_MASTER 203
#define COMMAND.I2C.I2C_READ_MASTER "Read data from I2C (Master mode)"(RIn_1"Slave address (7 bit address*2)",RIn_2"Slave register address",RIn_3"Read data destination Variable"){RIn_1=peripheral address<br>RIn_2=register address<br>RIn_3=readed value}-OUTPUT.I2CReadMaster

//******************************************************** Read data from I2C register (SLAVE MODE) **************************************************
//8 bit  [R]: Index the register where the read data will be stored
//8 bit  [R]: Index of the register containing the Slave register address to read
#define I2C_READ_REGISTER 204
#define COMMAND.I2C.I2C_READ_REGISTER "Read data from I2C register"(RIn_1"Read data destination Variable",RIn_2"Slave register address (7 bit address*2)"){RIn_1=readed value<br>RIn_2=index of I2C register}-OUTPUT.I2CReadRegister

//******************************************************** Write data to I2C register (SLAVE MODE) ***************************************************
//8 bit  [R]: Index of the register containing the data to be written
//8 bit  [R]: Index of the register containing the Slave register address to write
#define I2C_WRITE_REGISTER 205
#define COMMAND.I2C.I2C_WRITE_REGISTER "Write data to I2C register"(RIn_1"Value to write",RIn_2"Slave register address (7 bit address*2)"){RIn_1=value to write<br>RIn_2=index of I2C register}-OUTPUT.I2CWriteRegister

//******************************************************** Save I2C register to flash ****************************************************************
//16 bit [M]: Flash memory address where the value of the I2C register will be saved
#define I2C_STORE_TO_FLASH 206
#define COMMAND.I2C.I2C_STORE_TO_FLASH "Store I2C register to flash"(MemOut_1"Destination string"){MemOut_1=flash address}-OUTPUT.I2CStoreToFlash

//******************************************************** Read I2C register to flash ****************************************************************
//16 bit [M]: Flash memory address containing the value of the I2C register to load
#define I2C_READ_FROM_FLASH 207
#define COMMAND.I2C.I2C_READ_FROM_FLASH "Load I2C register from flash"(MemIn_1"Source string"){MemIn_1=flash address}-OUTPUT.I2CReadFromFlash

//----------------------------------------------------------------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------------------------------------------------------------------
//---------------------------------------------------- W I - F I   F U N C T I O N S -----------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------

//********************************************************* Enable WiFi module ***********************************************************************
#define WIFI_ENABLE 210
#define COMMAND.WIFI.WIFI_ENABLE "Enable WiFi module"(In8_1(1:UART1, 2:UART2)"Select UART"){Wi-Fi module enable<br>Module connect to UART In8_1}-OUTPUT.WiFiEnable

//********************************************************* Disable WiFi module **********************************************************************
#define WIFI_DISABLE 211
#define COMMAND.WIFI.WIFI_DISABLE "Disable WiFi module"(){Wi-Fi module disable}-OUTPUT.WiFiDisable

//******************************** Setting WiFi module to web server mode for setting autoconnct parameter *******************************************
#define WIFI_WEB_CONNECT 212
#define COMMAND.WIFI.WIFI_WEB_CONNECT "Setting WiFi module to web server mode for setting autoconnct parameter"(){Wi-Fi module in web server mode}-OUTPUT.WebServer


//*********************************************** Status of connection of WiFi module *****************************************************
//PARAMETER
//8 bit  [R]: Index of the register were store status of connection. if 0 module are correctly connected. If 1, module are not connected.
#define WIFI_CONNECTION_STATUS 213
#define COMMAND.WIFI.WIFI_CONNECTION_STATUS "Return connection status of WiFi module"(RIn_1"Numerical variable were store connection status. If 0 module correctly connected. If 1, module not are connected."){Connection status=RIn_1}-OUTPUT.WiFiStatus

//************************************ Prepare to write data to web server through WiFi **************************************************
//PARAMETER
//16 bit [I]: field ID of on-line WiFi page
//16 bit [M]: Memory address were are stored value will be write to on-line WiFi page
#define WIFI_PREPARE_WRITE_GET 214
#define COMMAND.WIFI.WIFI_PREPARE_WRITE_GET "Prepare string data to write to web server"(In16_1"Field ID of on-line WiFi page",MemIn_1"String value will be write to on-line WiFi page"){ID of web field=In16_1<br>Value to will be write=[MemIn_1]}-OUTPUT.WiFiWrite

//************************************ Prepare to write data to web server through WiFi **************************************************
//PARAMETER
//16 bit [I]: field ID of on-line WiFi page
//8 bit  [R]: index of register were are stored value will be write to on-line WiFi page
#define WIFI_PREPARE_WRITE_INT_GET 215
#define COMMAND.WIFI.WIFI_PREPARE_WRITE_INT_GET "Prepare numerical data to write to web server"(In16_1"Field ID of on-line WiFi page",RIn_1"Numerical value will be write to on-line WiFi page"){ID of web field=In16_1<br>Value to will be write=[RIn_1]}-OUTPUT.WiFiWrite


//************************************ Prepare to read data from web server through WiFi **************************************************
//PARAMETER
//16 bit [I]: field ID of on-line WiFi page
#define WIFI_PREPARE_READ_GET 216
#define COMMAND.WIFI.WIFI_PREPARE_READ_GET "Prepare data to read from web server"(In16_1"Field ID of on-line WiFi page"){ID of web field=In16_1}-OUTPUT.WiFiRead

//**************************************** Send data to web page through WiFi (previously prepared) ***************************************
//PARAMETER
//16 bit [M]: Memory address were store User ID of WiFi application
//16 bit [M]: Memory address were store User password of WiFi application
//16 bit [I]: ID of WiFi application of on-line WiFi page
//8 bit  [R]: Index of the register. if 0 data are correctly sended. If 1, data are not sending.
#define WIFI_DATA 217
#define COMMAND.WIFI.WIFI_DATA "Send data to web page"(MemIn_1"User ID of WiFi application",MemIn_2"User password of WiFi application",In16_1"ID of WiFi application of on-line WiFi page",RIn_1"Numerical variable were store result of web connection. If 0 data are correctly sended. If 1, data are not sending."){User ID=[MemIn_1]<br>User Password=[MemIn_2]<br>ID of application=In16_1<br>Result of connection=RIn_1}-OUTPUT.WiFiData

//***************************** Read variable stored in web server (previously readed from 'Send data' instruction) ***********************
//PARAMETER
//16 bit [M]: Memory address were store value readed from web server
//16 bit [I]: field ID of on-line WiFi page
//8 bit  [R]: Index of the register. if 0 data are correctly readed. If 1, data are not readed.
#define WIFI_READ_VARIABLE 218
#define COMMAND.WIFI.WIFI_READ_VARIABLE "Read variable from web server"(MemIn_1"Memory address were store value readed from web server",In16_1"Field ID of on-line WiFi page",RIn_1"Number variable were store if ID field is finded or not. If 0 field is finded. If 1, ID field is not finded"){Value readed=[MemIn_1]<br>ID of web field=In16_1<br>Field finded=RIn_1}-OUTPUT.WiFiVariable


//*************************** Read int variable stored in web server (previously readed from 'Send data' instruction) **********************
//PARAMETER
//8 bit  [R]: Index of register were store value readed from web server
//16 bit [I]: field ID of on-line WiFi page
//8 bit  [R]: Index of the register. if 0 data are correctly readed. If 1, data are not readed.
#define WIFI_READ_INT_VARIABLE 219
#define COMMAND.WIFI.WIFI_READ_INT_VARIABLE "Read int variable from web server"(RIn_1"Numerical variable were store value readed from web server",In16_1"Field ID of on-line WiFi page",RIn_2"Number variable were store if ID field is finded or not. If 0 field is finded. If 1, ID field is not finded"){Value readed=[RIn_1]<br>ID of web field=In16_1<br>Field finded=RIn_2}-OUTPUT.WiFiVariable


//******************************** Setting WiFi module to web server mode for setting autoconnct parameter *******************************************
#define WIFI_REBOOT 220
#define COMMAND.WIFI.WIFI_REBOOT "Rebbot WiFi module"(){Reboot Wi-Fi module}-OUTPUT.WiFiReboot


//----------------------------------------------------------------------------------------------------------------------------------------------------




//----------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------- M O D B U S   F U N C T I O N S ----------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------

//**************************************************** Turn on modbus *******************************************************************
//PARAMETER
//8 bit  [I]: port to connect MODBUS. If 1, MODBUS is connect to COM1, if 2, MODBUS is connect to COM2
//8 bit  [I]: speed selector. 
//			  0=2400, 
//			  1=4800, 
//			  2=9600
//			  3=14400
//			  4=19200
//			  5=28800
//			  6=38400
//			  7=57600
//			  8=76800
//			  9=115200
#define MODBUS_ON 230
#define COMMAND.MODBUS.MODBUS_ON "Turn MODBUS ON"(In8_1(1: COM1,2: COM2)"port to connect MODBUS", In8_2(0: 2400bps,1: 4800bps,2: 9600bps,3: 14400bps,4: 19200bps,5: 28800bps,6: 38400bps,7: 57600bps,8: 76800bps,9: 115200bps)"MODBUS speed"){MODBUS port=In8_1<br>MODBUS speed=In8_2}-OUTPUT.MODBUSOn

//*********************************************** Send command from MODBUS *************************************************************
//PARAMETER
//8 bit  [I]: Slave address
//8 bit  [I]: command 
//			  1= read boolean output variable
//			  2= read boolean input variable
//			  3= read output variable (16 bit)
//			  4= read input variable (16 bit)
//			  5= write boolean variable
//			  6= write variable
//16 bit  [I]: 1 data 
//			  if command 1 or 2: start address from read
//			  if command 3 or 4: start address from read
//			  if command 5: address to write
//			  if command 6: address to write
//16 bit  [I]: 2 data 
//			  if command 1 or 2: number of bit to read
//			  if command 3 or 4: number of word (16 bit) to read
//			  if command 5: value to write (0xFF00 to set ON, 0x0000 to set OFF)
//			  if command 6: value to write (16 bit)
//16 bit [M]: Address of numerical vector to store received data
//16 bit  [I]: Time Out in msec
#define MODBUS_SEND_COMMAND 231
#define COMMAND.MODBUS.MODBUS_SEND_COMMAND "MODBUS Send command"(In8_1"slave address", In8_2(1: read boolean output variable,2: read boolean input variable ,3: read 16 bit output variable,4: read 16 bit input variable,5: write boolean variable,6: write 16 bit variable)"MODBUS command", In16_1"1 data",In16_2"2 data", RegMemVectOut_1"Numerical vector to store data",ROut_1"Error CRC. If 1 no CRC error", In16_3"Time Out in msec"){Slave address=In8_1<br>Command=In8_2<br>1 data=In16_1<br>2 data=In16_2<br>Data readed=RegMemVectOut_1<br>CRC Error=ROut_1<br>Time Out=In16_3}-OUTPUT.MODBUSSendCommand

//*********************************************** Send command from MODBUS *************************************************************
//PARAMETER
//8 bit  [I]: Slave address
//8 bit  [I]: command 
//			  1= read boolean output variable
//			  2= read boolean input variable
//			  3= read output variable (16 bit)
//			  4= read input variable (16 bit)
//			  5= write boolean variable
//			  6= write variable
//16 bit  [I]: 1 data 
//			  if command 1 or 2: start address from read
//			  if command 3 or 4: start address from read
//			  if command 5: address to write
//			  if command 6: address to write
//16 bit  [I]: 2 data 
//			  if command 1 or 2: number of bit to read
//			  if command 3 or 4: number of word (16 bit) to read
//			  if command 5: value to write (0xFF00 to set ON, 0x0000 to set OFF)
//			  if command 6: value to write (16 bit)
//16 bit [M]: Address of numerical vector to store received data
//16 bit  [I]: Time Out in msec
#define MODBUS_SEND_COMMAND_STRING 231
#define COMMAND.MODBUS.MODBUS_SEND_COMMAND_STRING "MODBUS Send command and receive to string"(In8_1"slave address", In8_2(1: read boolean output variable,2: read boolean input variable ,3: read 16 bit output variable,4: read 16 bit input variable,5: write boolean variable,6: write 16 bit variable)"MODBUS command", In16_1"1 data",In16_2"2 data", MemOut_1"Numerical vector to store data",ROut_1"Error CRC. If 1 no CRC error", In16_3"Time Out in msec"){Slave address=In8_1<br>Command=In8_2<br>1 data=In16_1<br>2 data=In16_2<br>Data readed=MemOut_1<br>CRC Error=ROut_1<br>Time Out=In16_3}-OUTPUT.MODBUSSendCommand

//*********************************************** Send command from MODBUS *************************************************************
//PARAMETER
//8 bit  [I]: Slave address
//8 bit  [I]: command 
//			  1= read boolean output variable
//			  2= read boolean input variable
//			  3= read output variable (16 bit)
//			  4= read input variable (16 bit)
//			  5= write boolean variable
//			  6= write variable
//16 bit  [I]: 1 data 
//			  if command 1 or 2: start address from read
//			  if command 3 or 4: start address from read
//			  if command 5: address to write
//			  if command 6: address to write
//16 bit  [I]: 2 data 
//			  if command 1 or 2: number of bit to read
//			  if command 3 or 4: number of word (16 bit) to read
//			  if command 5: value to write (0xFF00 to set ON, 0x0000 to set OFF)
//			  if command 6: value to write (16 bit)
//16 bit [M]: Address of numerical vector to store received data
//16 bit  [I]: Time Out in msec
#define MODBUS_SEND_COMMAND_BYTE 233
#define COMMAND.MODBUS.MODBUS_SEND_COMMAND_BYTE "MODBUS Send command with byte data"(In8_1"slave address", In8_2(1: read boolean output variable,2: read boolean input variable ,3: read 16 bit output variable,4: read 16 bit input variable,5: write boolean variable,6: write 16 bit variable)"MODBUS command", In8_3"1 byte data H", In8_4"1 byte data L", In8_5"2 byte data H", In8_6"2 byte data L", RegMemVectOut_1"Numerical vector to store data",ROut_1"Error CRC. If 1 no CRC error", In16_1"Time Out in msec"){Slave address=In8_1<br>Command=In8_2<br>1 H data=In8_3<br>1 L data=In8_4<br>2 H data=In8_5<br>2 L data=In8_6<br>Data readed=RegMemVectOut_1<br>CRC Error=ROut_1<br>Time Out=In16_1}-OUTPUT.MODBUSSendCommand

//*********************************************** Send command from MODBUS *************************************************************
//PARAMETER
//8 bit  [I]: Slave address
//8 bit  [I]: command 
//			  1= read boolean output variable
//			  2= read boolean input variable
//			  3= read output variable (16 bit)
//			  4= read input variable (16 bit)
//			  5= write boolean variable
//			  6= write variable
//16 bit  [I]: 1 data 
//			  if command 1 or 2: start address from read
//			  if command 3 or 4: start address from read
//			  if command 5: address to write
//			  if command 6: address to write
//16 bit  [I]: 2 data 
//			  if command 1 or 2: number of bit to read
//			  if command 3 or 4: number of word (16 bit) to read
//			  if command 5: value to write (0xFF00 to set ON, 0x0000 to set OFF)
//			  if command 6: value to write (16 bit)
//16 bit [M]: Address of numerical vector to store received data
//16 bit  [I]: Time Out in msec
#define MODBUS_SEND_COMMAND_BYTE_STRING 233
#define COMMAND.MODBUS.MODBUS_SEND_COMMAND_BYTE_STRING "MODBUS Send command with byte data and receive to string"(In8_1"slave address", In8_2(1: read boolean output variable,2: read boolean input variable ,3: read 16 bit output variable,4: read 16 bit input variable,5: write boolean variable,6: write 16 bit variable)"MODBUS command", In8_3"1 byte data H", In8_4"1 byte data L", In8_5"2 byte data H", In8_6"2 byte data L", MemOut_1"Numerical vector to store data",ROut_1"Error CRC. If 1 no CRC error", In16_1"Time Out in msec"){Slave address=In8_1<br>Command=In8_2<br>1 H data=In8_3<br>1 L data=In8_4<br>2 H data=In8_5<br>2 L data=In8_6<br>Data readed=MemOut_1<br>CRC Error=ROut_1<br>Time Out=In16_1}-OUTPUT.MODBUSSendCommand


//*********************************************** Send command from MODBUS *************************************************************
//PARAMETER
//8 bit  [R]: Slave address
//8 bit  [I]: command 
//			  1= read boolean output variable
//			  2= read boolean input variable
//			  3= read output variable (16 bit)
//			  4= read input variable (16 bit)
//			  5= write boolean variable
//			  6= write variable
//16 bit  [I]: 1 data 
//			  if command 1 or 2: start address from read
//			  if command 3 or 4: start address from read
//			  if command 5: address to write
//			  if command 6: address to write
//16 bit  [I]: 2 data 
//			  if command 1 or 2: number of bit to read
//			  if command 3 or 4: number of word (16 bit) to read
//			  if command 5: value to write (0xFF00 to set ON, 0x0000 to set OFF)
//			  if command 6: value to write (16 bit)
//16 bit [M]: Address of numerical vector to store received data
//16 bit  [I]: Time Out in msec
#define MODBUS_SEND_COMMAND_REGISTER 232
#define COMMAND.MODBUS.MODBUS_SEND_COMMAND_REGISTER "MODBUS Send command(from variable)"(RIn8_1"slave address", In8_1(1: read boolean output variable,2: read boolean input variable ,3: read 16 bit output variable,4: read 16 bit input variable,5: write boolean variable,6: write 16 bit variable)"MODBUS command", In16_1"1 data",In16_2"2 data", RegMemVectOut_1"Numerical vector to store data",ROut_1"Error CRC. If 1 no CRC error"){Slave address=RIn8_1<br>Command=In8_1<br>1 data=In16_1<br>2 data=In16_2<br>Data readed=RegMemVectOut_1<br>CRC Error=ROut_1<br>Time Out=In16_3}-OUTPUT.MODBUSSendCommand



//----------------------------------------------------------------------------------------------------------------------------------------------------
//---------------------------------------------------- R S 4 8 5   F U N C T I O N S -----------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------

//**************************************************** Turn on modbus *******************************************************************
//PARAMETER
//8 bit  [I]: port to connect MODBUS. If 1, MODBUS is connect to COM1, if 2, MODBUS is connect to COM2
//8 bit  [I]: speed selector. 
//			  0=2400, 
//			  1=4800, 
//			  2=9600
//			  3=14400
//			  4=19200
//			  5=28800
//			  6=38400
//			  7=57600
//			  8=76800
//			  9=115200
#define RS485_ON 235
#define COMMAND.RS485.RS485_ON "Turn RS485 ON"(In8_1(1: COM1,2: COM2)"port to connect RS485", In8_2(0: 2400bps,1: 4800bps,2: 9600bps,3: 14400bps,4: 19200bps,5: 28800bps,6: 38400bps,7: 57600bps,8: 76800bps,9: 115200bps)"RS485 speed"){RS485 port=In8_1<br>RS485 speed=In8_2}-OUTPUT.MODBUSOn

//**************************************** Sending data to RS485 from Stringhe register **************************************************************
//PARAMETER
//16 bit [M]: Memory address where the string is stored
#define RS485_TX 236
#define COMMAND.RS485.RS485_TX "RS485 send data"(MemIn_1"String to send"){String to send=[MemIn_1]}-OUTPUT.UARTSend

//******************************************** Sending data to RS485 from Integer value ****************************************************************
//PARAMETER
//8 bit [R]:  Variable where the value is stored
#define RS485_TX_INTEGER 237
#define COMMAND.RS485.RS485_TX_INTEGER "RS485 send integer data"(RIn_1"Value to send"){Value to send=[RIn_1]}-OUTPUT.UARTSend

//******************************************** Sending data to RS485 from Integer value ****************************************************************
//PARAMETER
//8 bit [R]:  Variable where the value is stored
#define RS485_TX_BYTE 252
#define COMMAND.RS485.RS485_TX_BYTE "RS485 send byte data"(RIn_1"Value to send"){Value to send=[RIn_1]}-OUTPUT.UARTSend

//************************************* Receive data from RS485 and store to Stringhe register *********************************************************
//PARAMETER
//16 bit  [M]: Memory address where the received value will be stored
//8 bit  [R]: Index of the register containing the inactivity timeout (in ms). 0: no timeout
//8 bit  [R]: Number of characters befour exit of routine. If rhis value is 0, not consider this parameter
//8 bit  [R]: Index of the register containing the terminator character (when received the transmission is closed)
#define RS485_RX 238
#define COMMAND.RS485.RS485_RX "RS485 receive data (every read delete all data received)"(MemIn_1"Destination String",RIn_2"Inactivity timeout (ms). 0: no timeout", In8_1 "Number of characters befour exit of routine. If rhis value is 0, not consider this parameter", RIn_3"Terminator character (if value is different of 0, when received shut-down the transfer)"){RIn_1=Value received<br>Inactivity timeout=RIn_2<br>Number of character for exit=In8_1<br>Char to exit=RIn_3}-OUTPUT.UARTReceive


//**************************************** Receive data from RS485 and store to register ************************************************************
//PARAMETER
//8 bit  [R]: Variable where the received value will be stored
//8 bit  [R]: Index of the register containing the inactivity timeout (in ms). 0: no timeout
#define RS485_RX_INTEGER 239
#define COMMAND.RS485.RS485_RX_INTEGER "RS485 receive integer data (every read delete all data received)"(RIn_1"Destination variable",RIn_2"Inactivity timeout (ms). 0: no timeout"){RIn_1=Value received<br>Inactivity timeout=RIn_2}-OUTPUT.UARTReceive


//**************************************** Receive data from RS485 and store to register ************************************************************
//PARAMETER
//8 bit  [R]: Variable where the received value will be stored
//8 bit  [R]: Index of the register containing the inactivity timeout (in ms). 0: no timeout
#define RS485_RX_BYTE 253
#define COMMAND.RS485.RS485_RX_BYTE "RS485 receive byte data"(RIn_1"Destination variable",RIn_2"Inactivity timeout (ms). 0: no timeout", ROut_1"Save 1 if no time out; 0 if timeout"){RIn_1=Value received<br>Inactivity timeout=RIn_2<br>Error timeout=ROut_1}-OUTPUT.UARTReceive


//----------------------------------------------------------------------------------------------------------------------------------------------------
//-------------- D I S P L A Y   F U N C T I O N S (for I2C display with controller HD44780 example 2846-LCD16X2AI2C)  -------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------
//****************************************************** Turn ON display ************************************************************************
//PARAMETER
//8 bit  [I]: Slave address
#define DISPLAY_ON 240
#define COMMAND.DISPLAY.DISPLAY_ON "Turn ON I2C display"(In8_1"slave address (7 bit address*2)"){Slave address=In8_1}-OUTPUT.DISPLAYON

//****************************************************** Write to display ************************************************************************
//PARAMETER
//16 bit  [M]: Address of string to write to display
#define DISPLAY_WRITE 241
#define COMMAND.DISPLAY.DISPLAY_WRITE "Write to display"(MemIn_1"Source String to write"){String to write=MemIn_1}-OUTPUT.DISPLAYWrite

//*********************************************** Write to display at choosed address ************************************************************
//PARAMETER
//16 bit  [M]: Address of string to write to display
#define DISPLAY_WRITE_ADDRESS 242
#define COMMAND.DISPLAY.DISPLAY_WRITE_ADDRESS "Write to display at choosed address"(In8_1"slave address (7 bit address*2)",MemIn_1"Source String to write"){Slave address=In8_1<br>String to write=MemIn_1}-OUTPUT.DISPLAYWrite

//******************************************************** Clear display *************************************************************************
#define DISPLAY_CLEAR 243
#define COMMAND.DISPLAY.DISPLAY_CLEAR "Clear display"()-OUTPUT.DISPLAYClear

//****************************************************** Display cursor ON ***********************************************************************
#define DISPLAY_CURSOR_ON 244
#define COMMAND.DISPLAY.DISPLAY_CURSOR_ON "Turn ON display cursor"(){}-OUTPUT.DISPLAYCursorON

//****************************************************** Display cursor OFF **********************************************************************
#define DISPLAY_CURSOR_OFF 245
#define COMMAND.DISPLAY.DISPLAY_CURSOR_OFF "Turn OFF display cursor"(){}-OUTPUT.DISPLAYCursorOFF

//**************************************************** Display Back light ON *********************************************************************
#define DISPLAY_BL_ON 246
#define COMMAND.DISPLAY.DISPLAY_BL_ON "Turn ON display back light"(){}-OUTPUT.DISPLAYBLON
//**************************************************** Display Back light OFF ********************************************************************
#define DISPLAY_BL_OFF 247
#define COMMAND.DISPLAY.DISPLAY_BL_OFF "Turn OFF display back light"(){}-OUTPUT.DISPLAYBLOFF

//************************************************* Display beginning of line 1 ******************************************************************
#define DISPLAY_LINE_1 248
#define COMMAND.DISPLAY.DISPLAY_LINE_1 "Beginning of line 1 of display"(){}-OUTPUT.DISPLAYLine1
//************************************************* Display beginning of line 2 ******************************************************************
#define DISPLAY_LINE_2 249
#define COMMAND.DISPLAY.DISPLAY_LINE_2 "Beginning of line 2 of display"(){}-OUTPUT.DISPLAYLine2

//********************************************************* Enable WiFi module ***********************************************************************
//8 bit  [I]: port to connect Display. If 1, Display is connect to COM1, if 2, Display is connect to COM2
//8 bit  [I]: speed selector. 
//			  0=2400, 
//			  1=4800, 
//			  2=9600
//			  3=14400
//			  4=19200
//			  5=28800
//			  6=38400
//			  7=57600
//			  8=76800
//			  9=115200
//16 bit  [M]: Memory address conteined command
//16 bit  [M]: Memory address conteined value
//8 bit  [I]: send quotation marks. If 1, send quotation marks charapter, if 0, not send quotation marks charapter
#define DISPLAY_NEXTION_WRITE 250
#define COMMAND.DISPLAY.DISPLAY_NEXTION_WRITE "Write command to Nextion display"(In8_1(1:UART1, 2:UART2)"Select UART",In8_2(0: 2400bps,1: 4800bps,2: 9600bps,3: 14400bps,4: 19200bps,5: 28800bps,6: 38400bps,7: 57600bps,8: 76800bps,9: 115200bps)"RS232 speed",MemIn_1"String command",MemIn_2"String data",In8_3(0:not send quotation mark,1:send quotation mark)"Select UART"){Selected UART: In8_1<br>Speed UART: In8_2<br>Command: MemIn_1<br>Data: MemIn_2<br>Send quotation mark: In8_3}-OUTPUT.DisplayWrite


//*************************************************** Enter in program mode **********************************************************************
#define PROGRAM_DMBOARD 251
#define COMMAND.DMBOARD.PROGRAM_DMBOARD "Enter in Program mode"(){}-OUTPUT.Program


//----------------------------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------- C O M P I L E R    F U N C T I O N S ------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------------

//**************************************************** Compiler string length ************************************************************************
//8 bit  [I]: String length value
#define STRING_LENGTH 198
#define COMMAND.COMPILER.STRING_LENGTH "String length"(In8_1"String length"){String length=In8_1}-OUTPUT.NumbersIcon

//**************************************************** Test for Production ***************************************************************************
#define TEST_PRODUCTION 199
#define COMMAND.COMPILER.TEST_PRODUCTION "Test all function of board"( RIn_1"register contain result of test. If 0, test succesfully."){RIn_1=test result}-OUTPUT.NumbersIcon

//************************************************* Variables (only for DMDesign) ********************************************************************
#define COMMAND.VARIABLE.number "Define numerical variable"(In16_1"Name of the numerical variable"){In16_1}-VARIABLE.NumbersIcon
#define COMMAND.VARIABLE.number_mem "Define numerical flash variable"(In16_1"Name of the flash numerical variable",InRegMem16_1"Initial value of the variable"){In16_1=InRegMem16_1}-VARIABLE_global.NumbersIcon
#define COMMAND.VARIABLE.number_mem_vector "Define numerical vector"(In16_1"Name of the numerical vector variable",In16_2"Length of the vector"){In16_1[0..In16_2]=(0,0,0,...)}-VARIABLE_global.NumbersVectorIcon
//#define COMMAND.VARIABLE.string "Define string variable"(In16_1"Name of the string variable"){In16_1}-VARIABLE.StringIcon
#define COMMAND.VARIABLE.string_mem "Define string flash variable"(In16_1"Name of the string flash variable",InMem16_1"Initial value of the string"){In16_1=InMem16_1}-VARIABLE_global.StringIcon
#define COMMAND.VARIABLE.string_mem_vector "Define string vector"(In16_1"Name of the string vector variable",In16_2"Length of the vector"){In16_1[0..In16_2]=(0,0,0,...)}-VARIABLE_global.StringVectorIcon
#define COMMAND.VARIABLE.- "Jump to state"(J16_1"Jump target state"){Main state=J16_1}-STATE

//----------------------------------------------------------------------------------------------------------------------------------------------------

#define GROUP.LED "LED functions"
#define GROUP.JUMP "Jump functions"
#define GROUP.DELAY "Delay functions"
#define GROUP.IO "Input/Output functions"
#define GROUP.UART "UART functions"
#define GROUP.GSM "GSM functions"
#define GROUP.STRING "String/Register functions"
#define GROUP.ARITHMETIC "Arithmetic functions"
#define GROUP.TEST "Test functions"
#define GROUP.USB "USB functions"
#define GROUP.PWDOWN "Power Down functions"
#define GROUP.TIMER "Timer functions"
#define GROUP.VARIABLE "Variable functions"
#define GROUP.CHECKBATTERY "Battery functions"
#define GROUP.SOUND "Beep functions"
#define GROUP.I2C "I2C functions"
#define GROUP.WIFI "Wi-Fi functions"
#define GROUP.RS485 "RS485 functions"
#define GROUP.MODBUS "MODBUS functions"
#define GROUP.DISPLAY "DISPLAY functions"
#define GROUP.DMBOARD "DM BOARD functions"
//#define GROUP.COMPILER "Compiler functions"
